package org.springframework.boot.loader.archive;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;
import java.util.List;
import java.util.Objects;
import java.util.Spliterator;
import java.util.Spliterators;
import java.util.function.Consumer;
import java.util.jar.Manifest;
import org.springframework.boot.loader.archive.Archive;

public interface Archive extends Iterable<Archive.Entry>, AutoCloseable {
  default Iterator<Archive> getNestedArchives(EntryFilter searchFilter, EntryFilter includeFilter) throws IOException {
    EntryFilter combinedFilter = entry -> ((searchFilter == null || searchFilter.matches(entry)) && (includeFilter == null || includeFilter.matches(entry)));
    List<Archive> nestedArchives = getNestedArchives(combinedFilter);
    return nestedArchives.iterator();
  }
  
  @Deprecated
  default List<Archive> getNestedArchives(EntryFilter filter) throws IOException {
    throw new IllegalStateException("Unexpected call to getNestedArchives(filter)");
  }
  
  @Deprecated
  default void forEach(Consumer<? super Entry> action) {
    Objects.requireNonNull(action);
    for (Entry entry : this)
      action.accept(entry); 
  }
  
  @Deprecated
  default Spliterator<Entry> spliterator() {
    return Spliterators.spliteratorUnknownSize(iterator(), 0);
  }
  
  default boolean isExploded() {
    return false;
  }
  
  default void close() throws Exception {}
  
  URL getUrl() throws MalformedURLException;
  
  Manifest getManifest() throws IOException;
  
  @Deprecated
  Iterator<Entry> iterator();
}
